const { dirname, join } = require('path');
const { existsSync } = require('fs');
const { memoize } = require('./memoize');

/**
 * Find the path of the project's tsconfig from a path to a file in the project.
 *
 * @param {string} filepath
 * @returns {string | undefined}
 */
function findTsconfigImpl(filepath) {
    let dir = dirname(filepath);
    
    while (dir !== '/') {
        const tsconfig = join(dir, 'tsconfig.json');
        if (existsSync(tsconfig)) {
            return tsconfig;
        }
        dir = dirname(dir);
    }
    
    return undefined;
}

module.exports.findTsconfig = memoize(findTsconfigImpl);
